import base64
from os import environ
from tic.reputation.broadcaster.rep_update_broadcaster import RepUpdateBroadcaster

# This function reads reputation changes from reputation-categorize-loader-results kinesis stream and broadcast them to
# reputation-feed and reputation-feed-cbd kinesis streams

rep_stream_name = environ["reputation_stream_name"]

broadcaster = RepUpdateBroadcaster(rep_stream_name)


def handler(event, _):
    failed_data = []
    for record in event["Records"]:
        payload = base64.b64decode(record["kinesis"]["data"])
        failed_recs = broadcaster.process_message(payload)
        if len(failed_recs):
            failed_data.append(failed_recs)

    if len(failed_data):
        error = f"Failed to add {len(failed_data)} records {failed_data}"
        raise Exception(error)
