"""
mosaic2 config for gc consumer persister
"""
from tic.shared.base_config import BaseConfig


class RepConsumerPersisterConfig(BaseConfig):
    def __init__(self, port):
        super().__init__(
            service_name="gc_consumer_persister", port=port, init_boto_session=False
        )

        self.get_healthy_service_uri = None
        self.get_healthy_service_instance = None

        self.thread_count = 10

        # commercial side resources
        self.comm_aws_region = self.get("COMM_AWS_REGION")
        self.comm_sqs_name = self.get("COMM_SQS_NAME")
        self.comm_sqs_endpoint_url = self.get("COMM_SQS_ENDPOINT_URL")
        self.comm_s3_endpoint_url = self.get("COMM_S3_ENDPOINT_URL")

        # govCloud side resources
        self.aws_region = self.get("AWS_REGION")  # govCloud region
        self.kinesis_results_name = self.get("KINESIS_RESULTS_NAME")
        self.reputation_table_name = self.get("REP_DYNAMODB_TABLE_NAME")
        self.psc_expiration_bucket = self.get("PSC_EXPIRATION_BUCKET")
        self.persister_dlq = self.get("PERSISTER_DLQ")
        self.fips_s3_endpoint = self.get("FIPS_S3_ENDPOINT")

        self.comm_access_key_id = self.get("COMM_ACCESS_KEY_ID")
        self.comm_access_key = self.get("COMM_ACCESS_KEY")
        self.setup_boto_session(
            self.comm_aws_region, self.comm_access_key_id, self.comm_access_key
        )

        self.loaded = True
