"""
config file for the gc_repdb_importer app
"""
from tic.shared.base_config import BaseConfig


class GcRepDbimporterConfig(BaseConfig):
    def __init__(self, port):
        super().__init__(
            service_name="gc_repdb_importer", port=port, init_boto_session=False
        )

        self.get_healthy_service_uri = None
        self.get_healthy_service_instance = None

        self.thread_count = 20

        # AWS resources
        self.aws_region = self.get("AWS_REGION")
        self.reputation_table_name = self.get("REP_DYNAMODB_TABLE_NAME")
        self.rep_sqs_name = self.get("REP_DB_SQS")
        self.gc_sqs_endpoint = self.get("SQS_ENDPOINT")
        self.repdb_importer_dlq = self.get("IMPORTER_DLQ")
        self.repdb_expiry_sqs = self.get("EXPIRY_SQS")
        self.fips_s3_endpoint = self.get("FIPS_S3_ENDPOINT")

        self.loaded = True
