"""
principal configs for the rep_importer
"""
from flask_principal import Principal, Identity, RoleNeed, Need
from flask import g
from tic.shared.service import BasePrincipal, TicPrincipalData


class GcRebDbimporterPrincipal(BasePrincipal):
    def __init__(self):
        self.principal = None

    def create_principal(self, app):
        self.principal = Principal(app, use_sessions=False)
        self.principal.identity_loader(self.authenticate)

    def authenticate(self):

        user_id = 4000
        identity = Identity(user_id)
        identity.provides.add(RoleNeed("cb-customer"))
        identity.provides.add(Need("read", "reputation_data"))
        identity.provides.add(Need("create", "reputation_data"))
        identity.provides.add(Need("update", "reputation_data"))
        identity.provides.add(Need("delete", "reputation_data"))
        identity.provides.add(Need("read", "defense_data"))
        identity.provides.add(Need("create", "ubs_data"))

        self.principal.set_identity(identity)

        tic_principal_data = TicPrincipalData()
        tic_principal_data.user_id = user_id
        tic_principal_data.user_name = "internal_cluster"
        g.tic_principal_data = TicPrincipalData()
