from tic.shared.base_config import BaseConfig


class GcRepDbProcessorConfig(BaseConfig):
    def __init__(self, port):
        super().__init__(
            service_name="gc_repdb_processor", port=port, init_boto_session=False
        )

        self.get_healthy_service_uri = None
        self.get_healthy_service_instance = None

        # aws resource
        self.aws_region = self.get("AWS_REGION")
        self.rep_s3_bucket_name = self.get("REP_DB_S3")  # contains rep item files
        self.rep_s3_prefix = self.get("REP_DB_S3_PREFIX")
        self.rep_sqs_name = self.get("REP_DB_SQS")
        self.gc_sqs_endpoint = self.get("SQS_ENDPOINT")
        self.processor_dlq = self.get("PROCESSOR_DLQ")
        self.fips_s3_endpoint = self.get("FIPS_S3_ENDPOINT")

        self.loaded = True
