"""
mosaic2 config for rep persister
"""
from tic.shared.base_config import BaseConfig


class RepPersisterConfig(BaseConfig):
    def __init__(self, port):
        super().__init__(
            service_name="reputation_persister", port=port, init_boto_session=False
        )

        self.get_healthy_service_uri = None
        self.get_healthy_service_instance = None

        self.thread_count = 10

        self.aws_region = self.get("AWS_REGION")
        self.persister_sqs_name = self.get("PERSISTER_SQS_NAME")
        self.kinesis_results_name = self.get("KINESIS_RESULTS_NAME")
        self.reputation_table_name = self.get("REP_DYNAMODB_TABLE_NAME")
        self.psc_expiration_bucket = self.get("PSC_EXPIRATION_BUCKET")

        self.loaded = True
