import abc
from future.utils import with_metaclass


class ScoreCalculatorBase(with_metaclass(abc.ABCMeta, object)):
    @abc.abstractmethod
    def calculate(self, reputation_score):
        """
        :param reputation_score: a reputation score dictionary to calculate
        :return: None
        """

    @abc.abstractmethod
    def version(self):
        """
        :return: the algorithm version being used
        """
