from datetime import datetime
from tic.shared.ubs.dtos.analysis.timing import UbsAnalysisTiming


class ApcLookupTiming(UbsAnalysisTiming):
    def __init__(
        self,
        first_lookup: datetime = None,
        upload_state_set: datetime = None,
        final_poll_for_result: datetime = None,
        result_received: datetime = None,
    ):
        super().__init__()
        self.first_lookup = first_lookup
        self.upload_state_set = upload_state_set
        self.final_poll_for_result = final_poll_for_result
        self.result_received = result_received

        super().decode_settings.update(
            {
                "first_lookup": self.from_iso_8601_if_present,
                "upload_state_set": self.from_iso_8601_if_present,
                "final_poll_for_result": self.from_iso_8601_if_present,
                "result_received": self.from_iso_8601_if_present,
            }
        )

        super().encode_settings.update(
            {
                "first_lookup": self.to_iso_8601_if_present,
                "upload_state_set": self.to_iso_8601_if_present,
                "final_poll_for_result": self.to_iso_8601_if_present,
                "result_received": self.to_iso_8601_if_present,
            }
        )
