from ...enums.analysis.stage import UbsAnalysisStage
from ....dto import Dto


class UbsAnalysisStageTriggerEvent(Dto):
    decode_settings = {
        "stage": lambda x: UbsAnalysisStage(x),
    }

    encode_settings = {
        "stage": lambda x: x.value,
    }

    def __init__(
        self,
        s3_key=None,
        sha256=None,
        sha256_truncated=None,
        magic=None,
        stage: UbsAnalysisStage = None,
        is_test_file=False,
    ):
        self.s3_key = s3_key
        self.sha256 = sha256
        self.sha256_truncated = sha256_truncated
        self.stage = stage
        self.magic = magic
        self.is_test_file = is_test_file
