"""
Where we currently do IOC validation -

cbfeed_mgmt
    cbfeed_mgmt does IOC validation on individual IOCs and lists of IOCs.
    Individual IOCs - IPv4 Addresses - cbfeed_mgmt.CbFeedMgmtService.filter_ipv4_list
        Using netaddr to validate that the IP address is in the public space
        Using regular expressions
        Compares all IP Addresses to a cleanlist in a database.
    Individual IOCs - DNS - cbfeed_mgmt.CbFeedMgmtService.filter_dns_list
        No individual DNS ioc validation done.
        Compares all new DNS entries to a cleanlist in a database.
    Individual IOCs - Hash - cbfeed_mgmt.CbFeedMgmtService.filter_md5_list
        Regex matching to ensure the MD5 is 32 characters long - "if not re.match(r'\\w{32}', md5)" - INSUFFICIENT
        Compares all new MD5 entries to a cleanlist in a database.

cbfeed_ops
    score_threshold is set for each feed that will query reputation for the md5 and network indicators
        No checking of data is done before.


Python modules used -

    For IP address validation
IPy - used in tic.shared.utils.parser.network
netaddr - used in -
    src/tic/horizon/api/cb.py
    src/tic/cbfeed_mgmt/cbfeed_mgmt.py

tic.shared.utils.parser.hash is widely used - over a dozen different services import this library
tic.shared.utils.parser.network is less widely used - only 3 services import this library
    VirusTotal, Network Reputation and Classification

CLEANLISTING
    We also do indicator cleanlisting in a few places
        VirusTotal - domain cleanlist

Improper hash checking - There are multiple cases where we only check a hash for the proper length and not the proper characters
src/tic/detonation/misc.py:    if len(hash) == 32:
src/tic/cbfeed_mgmt/feed.py:            if 32 != len(md5):
src/tic/cbfeed_mgmt/cbfeed_mgmt.py:            if not re.match(r'\\w{32}', md5):
src/tic/portal/portal.py:        if len(hash) == 32 or len(hash) == 64:
    Solution - Create individual functions to check for a specific valid hash
        is_valid_md5 in parsers.hash
"""

__author__ = "rpeck"
