import dateutil.tz
import dateutil.parser
from datetime import datetime

"""
Set of utility functions for representing UTC datetime and converting between datetime and ISO (RFC3339) strings
"""


def get_utc_now():
    return datetime.now(dateutil.tz.tzutc())


def get_utc_now_string():
    return datetime_to_string(get_utc_now())


def datetime_to_string(dt):
    return dt.isoformat()


def get_utc_epoch():
    return datetime(1970, 1, 1, tzinfo=dateutil.tz.tzutc())
