from .util import validate_and_normalize_sha256

from ....shared.dto import Dto


class DownloadRequestBody(Dto):
    def __init__(self, sha256=None, expiration_seconds=3600):
        self.sha256 = sha256 if sha256 is not None else list()
        self.expiration_seconds = expiration_seconds

    def validate_and_normalize_request(self):
        self.sha256 = validate_and_normalize_sha256(self.sha256)

        if len(self.sha256) > 100:
            raise Exception(
                "No more than 100 files may be requested for download in a call"
            )
