from typing import List

from ....shared.dto import Dto


class FoundResult(Dto):
    def __init__(self, sha256=None, url=None):
        self.sha256 = sha256
        self.url = url


class DownloadResults(Dto):
    decode_settings = {
        "found": lambda x: list()
        if x is None
        else [FoundResult.from_dict(y, True, True) for y in x]
    }
    encode_settings = {
        "found": lambda x: list() if len(x) == 0 else [y.to_dict(True, True) for y in x]
    }

    def __init__(
        self,
        found: List[FoundResult] = None,
        not_found: List[FoundResult] = None,
        error: List[FoundResult] = None,
    ):
        # this has to be done this way because lists are mutable.
        self.found = found if found is not None else list()
        self.not_found = not_found if not_found is not None else list()
        self.error = error if error is not None else list()
