from ....shared.dto import Dto


class MetadataResults(Dto):
    def __init__(
        self,
        sha256,
        architecture=None,
        available_file_size=None,
        charset_id=None,
        comments=None,
        company_name=None,
        copyright=None,
        file_available=False,
        file_description=None,
        file_size=None,
        file_version=None,
        internal_name=None,
        lang_id=None,
        md5=None,
        original_filename=None,
        os_type=None,
        private_build=None,
        product_description=None,
        product_name=None,
        product_version=None,
        special_build=None,
        trademark=None,
    ):
        self.sha256 = sha256
        self.architecture = architecture if architecture is not None else []
        self.available_file_size = available_file_size
        self.charset_id = charset_id
        self.comments = comments
        self.company_name = company_name
        self.copyright = copyright
        self.file_available = file_available
        self.file_description = file_description
        self.file_size = file_size
        self.file_version = file_version
        self.internal_name = internal_name
        self.lang_id = lang_id
        self.md5 = md5
        self.original_filename = original_filename
        self.os_type = os_type
        self.private_build = private_build
        self.product_description = product_description
        self.product_name = product_name
        self.product_version = product_version
        self.special_build = special_build
        self.trademark = trademark


class BulkMetadataResult(Dto):
    """
    For bulk requests we return a more limited set of results.
    """

    def __init__(
        self,
        sha256,
        charset_id=None,
        comments=None,
        company_name=None,
        copyright=None,
        file_description=None,
        file_version=None,
        internal_name=None,
        lang_id=None,
        original_filename=None,
        private_build=None,
        product_description=None,
        product_name=None,
        product_version=None,
        special_build=None,
        trademark=None,
    ):
        self.sha256 = sha256
        self.charset_id = charset_id
        self.comments = comments
        self.company_name = company_name
        self.copyright = copyright
        self.file_description = file_description
        self.file_version = file_version
        self.internal_name = internal_name
        self.lang_id = lang_id
        self.original_filename = original_filename
        self.private_build = private_build
        self.product_description = product_description
        self.product_name = product_name
        self.product_version = product_version
        self.special_build = special_build
        self.trademark = trademark
