from ....shared.dto import Dto


class SignatureResults(Dto):
    def __init__(
        self,
        sha256,
        total_signatures_count=None,
        signatures_count=None,
        signatures=None,
    ):

        self.sha256 = sha256
        self.total_signatures_count = total_signatures_count
        self.signatures_count = signatures_count
        self.signatures = signatures if signatures is not None else []


class Signature(Dto):
    def __init__(
        self,
        count=None,
        is_catalog_signature=None,
        publisher_name=None,
        issuer_name=None,
        sign_timestamp=None,
        sign_states=None,
    ):

        self.count = count
        self.is_catalog_signature = is_catalog_signature
        self.publisher_name = publisher_name
        self.issuer_name = issuer_name
        self.sign_timestamp = sign_timestamp
        self.sign_states = sign_states if sign_states is not None else []


class SignState(Dto):
    def __init__(self, device_count=None, sign_state=None, first_seen_timestamp=None):

        self.device_count = device_count
        self.sign_state = sign_state if sign_state is not None else []
        self.first_seen_timestamp = first_seen_timestamp
