"""
This has no real authentication.
This class simply gives everyone UBS frontend permissions.
Use with care! This is only intended to be used for internal comms.
"""

from flask_principal import Principal, Identity, RoleNeed, Need
from flask import g

from tic.shared.service import BasePrincipal, TicPrincipalData


class UbsFrontendPrincipal(BasePrincipal):
    def __init__(self):
        self.principal = None

    def create_principal(self, app):
        self.principal = Principal(app, use_sessions=False)
        self.principal.identity_loader(self.authenticate)

    def authenticate(self):
        """
        Everything in here represents providing hard-coded permissions to UBS.
        This comes from real values.

        WARNING: No auth is being done!
        """

        user_id = 4000
        identity = Identity(user_id)
        identity.provides.add(RoleNeed("cb-customer"))
        identity.provides.add(Need("read", "ubs_data"))
        self.principal.set_identity(identity)

        tic_principal_data = TicPrincipalData()
        tic_principal_data.user_id = user_id
        tic_principal_data.user_name = "internal_cluster"
        g.tic_principal_data = TicPrincipalData()
