# Native imports
from base64 import b64decode, b64encode

try:
    import snappy
except ImportError:
    pass


def handler(event, _):
    return {
        "records": [
            {
                "recordId": record["recordId"],
                "result": "Ok",
                "data": b64encode(
                    snappy.decompress(b64decode(record["data"])) + b"\n"
                ).decode(),
            }
            for record in event["records"]
        ]
    }
